import java.awt.*;
import java.util.*;

public class Cell
{
    private double timesVisited;
    private boolean isValid = true;
    private Loc location;
    private boolean occupied;
    String loc = "";
    
    public Cell(Loc l, boolean isV)
    {
        location = l.clone();
        isValid = isV;
    }
    
    public void setLoc(String s)
    {   loc = s;    }
    
    public String getDesc()
    {
        return loc;
    }
    
    public boolean isValid()
    {
        return isValid;
    }
    
    public void toggleValid()
    {   isValid = !isValid; }
    
    public void setValid(boolean b)
    {   isValid = b;    }
    
    public Loc getLoc()
    {
        return location;
    }
    
    public int getR()
    {
        return location.getR();
    }
    
    public int getC()
    {
        return location.getC();
    }
    
    public void visit()
    {
        timesVisited++;
    }
    
    public void enter()
    {
        occupied = true;
        timesVisited++;
    }
    public void leave()
    {   occupied = false;   }
    
    public double getHealth()
    {
        return timesVisited;
    }
    
    public void changeHealth(double d)
    {
        timesVisited+=d;
    }
    
    public double getDistanceToo(Cell c)
    {
        Loc l = c.getLoc();
        int r1 = location.getR();
        int c1 = location.getC();
        int r2 = l.getR();
        int c2 = l.getC();
        return Math.sqrt( (r2-r1)*(r2-r1) + (c2-c1)*(c2-c1) );
    }
    
    public int limit(double n)
    {
        if(n>225)
        {   return 225; }
        if(n<0)
        {   return 0;   }
        else
        {   return (int)n;   }
    }
    
    public void draw(Graphics2D g2)
    {
        Color c = Color.BLACK;
        if(isValid)
        {   c = Color.WHITE;    }
        //new Color(225-limit(timesVisited*20),225-limit(timesVisited*20), 225);  }
        if(occupied)
        {   c = Color.RED;  }
        if(getR()==8 && getC()==8)
        {   c = Color.GREEN;    }
        if(occupied && getR()==8 && getC()==8)
        {   c = Color.BLUE;     }
        Rectangle r = new Rectangle(getC()*25, getR()*25, 25, 25);
        g2.setColor(c);
        g2.fill(r);
        g2.setColor(Color.BLACK);
        g2.draw(r);
    }
}