import java.util.*;

public class Droid
{
    private Maze maze;
    private Cell location;
    private Sensor sensor = new Sensor();;
    private Cell goal;
    private int time = 0;
    
    private boolean inDeadEndHall = false;
    
    public boolean run = false;
    
    public void toggle()
    {   run = !run;     }
    
    public Droid(Maze m, Cell c, Cell g)
    {
        maze = m;
        location = c;
        goal = g;
    }
    
    public Droid(Maze m)
    {
        maze = m;
    }
    
    public void setStart(Cell c)
    {
        location = c;
        location.changeHealth(0);
    }
    
    public void setEnd(Cell c)
    {   goal = c;   }
    
    public Cell chooseMove()
    {
        ArrayList<Cell> cells = sensor.removeInvalidCells(sensor.getAdjacentCells(maze, location) );
        Cell choice = null;
        Cell closest = null;
        double health = Double.MAX_VALUE;
        double distance = Double.MAX_VALUE;
        for(int i=0; i<cells.size(); i++)
        {
            if(cells.get(i).getDistanceToo(goal)<=distance)
            {
                closest = cells.get(i);
                distance = cells.get(i).getDistanceToo(goal);
                
            }
            //System.out.println(cells.get(i).getDesc()+ " - " + cells.get(i).getDistanceToo(goal));
        }
        //System.out.println("\n");
        closest.changeHealth(-.1);
        
        for(Cell c : cells)
        {
            if(c.getHealth()<=health)
            {
                choice = c;
                health = c.getHealth();
            }
        }
        return choice;
    }
    
    public void think()
    {
        if(sensor.getNumConnectingCells(maze, location)<2)
        {   inDeadEndHall = true;   }
        if(inDeadEndHall && sensor.getNumConnectingCells(maze, location)==2)
        {   inDeadEndHall = true;   }
        if(sensor.getNumConnectingCells(maze, location)>2)
        {   inDeadEndHall = false;  }
        if(inDeadEndHall)
        {   location.changeHealth(1000);   }
    }
    
    public void move()
    {
        if(location!=goal)
        {
            Cell l = chooseMove();
            location.leave();
            location = l;
            //location = chooseMove();
            location.enter();
            location.changeHealth(1);
        }
    }
    
    public void run()
    {
        if(run)
        {
            think();
            move();
        }
    }
}