import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.ArrayList;
import java.util.Random;
import java.util.Scanner;
import java.io.*;

public class MazeRunner
{
    public static void main(String[] args)
    {
        final JFrame frame = new JFrame();
        frame.setBackground(Color.GRAY);
        
        frame.setSize(750, 750);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setTitle("Maze");
        
        final Maze m = new Maze(25, 25);
        final Droid d = new Droid(m);
        Loc start = new Loc(1,1);
        Loc end = new Loc(8,8);
        d.setStart(m.getCell(start));
        m.getCell(start).enter();
        d.setEnd(m.getCell(end));
        m.addDroid(d);
        
        class Comp extends JComponent
        {
            public void paintComponent(Graphics g)
            {
                Graphics2D g2 = (Graphics2D) g;
                m.draw(g2);
            }
        }
        
        class Keyboard extends KeyAdapter
        {
            public void keyPressed(KeyEvent k)
            {
                
            }
            
            public void keyReleased(KeyEvent k)
            {
                if(k.getKeyChar()=='p')
                {   d.toggle(); }
                if(k.getKeyChar()=='s')
                {
                    d.toggle();
                    d.run();
                    d.toggle();
                }
                if(k.getKeyChar()=='a')
                {   m.saveMaze();   }
            }
            
            public void keyTyped(KeyEvent k)
            {
                
            }
        }
        
        class Physics implements ActionListener
        {
            public void actionPerformed(ActionEvent e)
            {
                d.run();
                frame.repaint();
            }
        }
        
        class Dragger extends MouseMotionAdapter
        {
            public void mouseDragged(MouseEvent e)
            {
                m.on(e.getY()-24, e.getX()-1);
                
            }
        }
        
        class Clicker extends MouseAdapter
        {
            public void mouseClicked(MouseEvent e)
            {
                m.click(e.getY()-24, e.getX()-1);
            }
            
            public void mousePressed(MouseEvent e)
            {
                
            }
        }
        Comp comp = new Comp();
        frame.add(comp);
        Keyboard keyer = new Keyboard();
        Clicker clicker = new Clicker();
        frame.addMouseListener(clicker);
        frame.addKeyListener(keyer);
        MouseMotionAdapter dragger = new Dragger();
        frame.addMouseMotionListener(dragger);
        Physics time = new Physics();
        Timer t = new Timer(50, time);
        t.start();
        frame.repaint();
        frame.setVisible(true);
    }
}